import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

/*Class: Huffy_Compress 
 * Classe main per comprimere il file 
 * 
 */


public class Huffy_Compress {
	
	public static void main(String[] args) throws IOException  {

		String File_Name=args[0];
		
		File in=new File(File_Name);
		OutputStream out=new FileOutputStream(File_Name.substring(0,File_Name.length()-4)+".huff");
		FileInputStream f= new FileInputStream(File_Name);
		
		long len=in.length();
		
		Array Elenco_Char= new Array();
		long i=0;

		System.out.println("Compressione in corso...");
		
		while(i<len) {
	
			long y=0;
			while(Elenco_Char.getmax()<255 && y+i<len) {
				y++;
				int x=f.read();
				Elenco_Char.Inserisci(x);
			}
			
			FileInputStream f_2=new FileInputStream(File_Name);
			codify(Elenco_Char,i,i+=y,f_2,out);
			
			f_2.close();
			Elenco_Char=new Array();
		}
		
		f.close();
		out.close();
		System.out.println("Compressione terminata");
	}

/* Method: codify 
 * Metodo che codifica il frammento di input analizzato fino al momento della chiamata al metodo stesso
 * 
 */

	
	public static void codify(Array Elenco_Char,long x,long y,FileInputStream f_2,OutputStream out) throws IOException {
		
		int size=Elenco_Char.GetSize();
		Nodo[] Values=new Nodo[size];
		
		for(int i=0;i<size;i++) {
			Values[i]=new Nodo(Elenco_Char.getChar()[i],Elenco_Char.getFrequenze()[i]);
		}
		
		HuffMan_Tree H= new HuffMan_Tree(size);
		H.Fill(Values,size);
		
		String Codifica_Grezza="";
		
		for(long i=0;i<x;i++) {
			f_2.read();
		}
		
		char aux;
		for(long i=0;i<y-x;i++) {
			aux=(char)f_2.read();
			Codifica_Grezza += H.find_Code(aux);
		}
		
		Metodi_file.WriteByteArray(Codifica_Grezza.length(), out);
		
		out.write((byte)size);
		
		Metodi_file.write_values(H.get_Chars(), out);
		Metodi_file.scrivi_Stringa_per_Byte(Codifica_Grezza,out);
		
	}
	
	
}
