import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.nio.ByteBuffer;

public class Huffy_Decompress {

	public static void main(String[] args) throws IOException {
		
		String File_Name= args[0];

		InputStream f= new FileInputStream(File_Name);
		OutputStream out=new FileOutputStream(File_Name.substring(0,File_Name.length()-5));
		File f_1= new File(File_Name);
		
		int cont=0;
		long a=f_1.length();
		
		int cod_length;
		int n_char;
		Nodo[] toFill;
		char aux_c;
		int aux;

		System.out.println("Decompressione in corso...");
		
		while(cont<a) {
		
			
			byte[] array=new byte[4];
			
			for(int i=0;i<4;i++) {
				array[i]=(byte)f.read();
			}
			cont+=4;
			
			cod_length=ByteBuffer.wrap(array).getInt();
			
			n_char=f.read();
			cont++;
			

			toFill=new Nodo[n_char];

			
			
			for(int j=0;j<n_char;j++) {
				aux_c=(char)f.read();
				aux=f.read();
				
				cont+=2;
				toFill[j]=new Nodo(aux_c,aux);
			}
			
			HuffMan_Tree H= new HuffMan_Tree(n_char);
			H.Fill(toFill, n_char);
		
			String cod="";
			String s=null;
			boolean resto=cod_length % 8 == 0 ?  false : true;
			
			long Read_Length=(long) Math.ceil(cod_length/8);
			
			
			for(long x=0;x<Read_Length;x++) {
				s=(String)Integer.toBinaryString(f.read());
				cont++;
				int diff=8-s.length();
				for(int j=0;j<diff;j++) cod+='0';
				cod+=s;	
			}
			
			if(resto) {
				s=(String)Integer.toBinaryString(f.read());
				cont++;
				int cod_diff=cod_length-8*((int)cod_length/8)-s.length();
				for(int j=0;j<cod_diff;j++) cod+='0';
				cod+=s;
			}
			
			String dec=H.Decode(cod);
			Metodi_file.scrivi_file(out,dec );
		
		}
		f.close();
		out.close();
		
		System.out.println("Decompressione Terminata");
	}
	
}
